Package: groovy.mock.interceptor

## [Java] Class MockProxyMetaClass

- groovy.mock.interceptor.MockProxyMetaClass

- The ProxyMetaClass for the MockInterceptor. Instance and class methods are intercepted, but constructors are not to allow mocking of aggregated objects.

  Authors:
    Dierk Koenig

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `boolean` | `interceptConstruction` |

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class ProxyMetaClass` | `EMPTY_ARGUMENTS`
    `class MetaClassImpl` | `EMPTY_ARGUMENTS`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `def` | `MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee)` @param adaptee the MetaClass to decorate with interceptability
    `def` | `MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee, boolean interceptConstruction)` @param adaptee the MetaClass to decorate with interceptability
    `Object` | `getProperty(Class aClass, Object object, String property, boolean b, boolean b1)`
    `Object` | `invokeConstructor(Object[] arguments)` Unlike general impl in superclass, ctors are not intercepted but relayed unless interceptConstruction is set.
    `Object` | `invokeMethod(Object object, String methodName, Object[] arguments)`
    `Object` | `invokeStaticMethod(Object object, String methodName, Object[] arguments)`
    `static MockProxyMetaClass` | `make(Class theClass)` convenience factory method for the most usual case.
    `static MockProxyMetaClass` | `make(Class theClass, boolean interceptConstruction)` convenience factory method allowing interceptConstruction to be set.
    `void` | `setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ProxyMetaClass` | `invokeConstructor, invokeStaticMethod, use, use, getAdaptee, setAdaptee, getInterceptor, setInterceptor, invokeMethod, setProperty, getProperty, getInstance, initialize, hasProperty, getTheClass, pickMethod, getMetaProperty, getStaticMetaMethod, getMetaMethod, getClassNode, respondsTo, respondsTo, invokeMissingMethod, invokeMissingProperty, getMetaMethods, selectConstructorAndTransformArguments, getClassInfo, incVersion, addNewInstanceMethod, addNewStaticMethod, getMethodWithCaching, retrieveConstructor, retrieveConstructor, retrieveStaticMethod, addMetaBeanProperty, isModified, createStaticSite, createPogoCallSite, createPogoCallCurrentSite, createConstructorSite, getTheCachedClass, getMethodWithoutCaching, isGroovyObject, getEffectiveGetMetaProperty, addMetaMethod, getAdditionalMetaMethods, createPojoCallSite, setAttribute, setAttribute, getAttribute, getAttribute, getAttribute, invokeMethod, invokeMethod, getRegistry, getVersion, setProperty, getProperty, toString, getMethods, getProperties, setProperties, wait, wait, wait, equals, hashCode, getClass, notify, notifyAll`
    `class MetaClassImpl` | `hasProperty, getTheClass, pickMethod, getMetaProperty, getStaticMetaMethod, invokeConstructor, invokeStaticMethod, getMetaMethod, getClassNode, respondsTo, respondsTo, invokeMissingMethod, invokeMissingProperty, getMetaMethods, selectConstructorAndTransformArguments, getClassInfo, incVersion, addNewInstanceMethod, addNewStaticMethod, getMethodWithCaching, retrieveConstructor, retrieveConstructor, retrieveStaticMethod, addMetaBeanProperty, isModified, createStaticSite, createPogoCallSite, createPogoCallCurrentSite, createConstructorSite, getTheCachedClass, getMethodWithoutCaching, isGroovyObject, getEffectiveGetMetaProperty, addMetaMethod, getAdditionalMetaMethods, createPojoCallSite, setAttribute, setAttribute, getAttribute, getAttribute, getAttribute, invokeMethod, invokeMethod, invokeMethod, getRegistry, getVersion, setProperty, setProperty, getProperty, getProperty, toString, getMethods, getProperties, setProperties, initialize, wait, wait, wait, equals, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public final boolean interceptConstruction

  - ### Method Detail

    - #### public def MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee)

      Parameters:
        `adaptee` - the MetaClass to decorate with interceptability

    - #### public def MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee, boolean interceptConstruction)

      Parameters:
        `adaptee` - the MetaClass to decorate with interceptability

    - #### public Object getProperty(Class aClass, Object object, String property, boolean b, boolean b1)

    - #### public Object invokeConstructor(Object[] arguments)

      Unlike general impl in superclass, ctors are not intercepted but relayed unless interceptConstruction is set.

    - #### public Object invokeMethod(Object object, String methodName, Object[] arguments)

    - #### public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)

    - #### public static MockProxyMetaClass make(Class theClass)

      convenience factory method for the most usual case.

    - #### public static MockProxyMetaClass make(Class theClass, boolean interceptConstruction)

      convenience factory method allowing interceptConstruction to be set.

    - #### public void setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)